package tofly.opc_gateway.config;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by huangdecai on 2023/4/19.
 * OPC server configuration
 */
@Configuration
@ConfigurationProperties(prefix = "opc.gateway.servers")
public class OpcServerProperties {

    private Map<String, ServerConfiguration> mappings = new LinkedHashMap<>();

    public OpcServerProperties() {
        super();
    }

    public Map<String, ServerConfiguration> getMappings() {
        return mappings;
    }

    public void setMappings(Map<String, ServerConfiguration> mappings) {
        this.mappings = mappings;
    }

    public static class ServerConfiguration {
        private final static String DEFAULT_HOST = "127.0.0.1";
        private final static int DEFAULT_PERIOD = 1000;
        private String host;

        private String user;

        private String password;

        private String clsid;

        private int period;

        private Map<String, List<Map<String, String>>> deviceMappings = new LinkedHashMap<>();

        public ServerConfiguration() {
            this.host = DEFAULT_HOST;
            this.period = DEFAULT_PERIOD;
        }

        public String getHost() {
            return host;
        }

        public void setHost(String host) {
            this.host = host;
        }

        public String getUser() {
            return user;
        }

        public void setUser(String user) {
            this.user = user;
        }

        public String getPassword() {
            return password;
        }

        public void setPassword(String password) {
            this.password = password;
        }

        public String getClsid() {
            return clsid;
        }

        public void setClsid(String clsid) {
            this.clsid = clsid;
        }

        public int getPeriod() {
            return period;
        }

        public void setPeriod(int period) {
            this.period = period;
        }

        public Map<String, List<Map<String, String>>> getDeviceMappings() {
            return deviceMappings;
        }

        public void setDeviceMappings(Map<String, List<Map<String, String>>> deviceMappings) {
            this.deviceMappings = deviceMappings;
        }
    }


}
